	ORG $1000-2
	DW  $1000
	
;	DW $100B,0
;	DB $9E,"4109",0,0,0
	
	include "!playerv.asm"
OFS		= 0

txtptr		= $E0
delay		= $E4
lines		= $D0
line_add	= $D1
sine1		= $D2
ptr		= $C8
ptr2		= $CA

cnt_lo		= $17	; assume value is $16 on init
cnt_hi		= $C0	; assume value is $00 on init  
add_value	= $C1	; assume value is $00 on init 

sine		= $0600	; can go anywhere

	include "font.asm"

plasma_colors
	DB $68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68,$68
	DB $62,$62,$62,$62,$62,$62,$62,$62,$62,$62,$62,$62,$62,$62,$62,$62,$62,$62
	DB $6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b,$6b
	DB $64,$64,$64,$64,$64,$64,$64,$64,$64,$64,$64,$64,$64,$64,$64,$64,$64,$64
	DB $6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E,$6E
	DB $66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66,$66
	DB $6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d,$6d
	DB $63,$63,$63,$63,$63,$63,$63,$63,$63,$63,$63,$63,$63,$63,$63,$63,$63,$63
	DB $6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C,$6C
	DB $65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65
	DB $6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F,$6F
	DB $6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A,$6A
	DB $67,$67,$67,$67,$67,$67,$67,$67,$67,$67,$67,$67,$67,$67,$67,$67,$67,$67
	DB $69,$69,$69,$69,$69,$69,$69,$69,$69,$69,$69,$69,$69,$69,$69,$69,$69,$69
	;
	SEI
	;
	; ------------------------
	;  Generate "sine" table
	;
	; really a parabola, but similar enough to a sine
	; 
	LDA #$00
	STA cnt_hi
	STA add_value
	PHA			; keep add value on stack
	LDA #$16
	STA cnt_lo
	LDY #$FF		; y=$FF, counts down
	;
loop	LDA cnt_lo
	ADC #$07
	STA cnt_lo
	BCC *+4
	INC add_value
	ADC cnt_hi
	STA cnt_hi
	;
	PLA
	ADC add_value
	PHA
	;
	STA sine,x		; 1st segment
	STA sine+$100,x		;     replicate 1st again, because plasma reads over the page boundary
	STA sine,y		; 4th segment (same as 1 but backwards)
	EOR #$7F		;     two's complement (same as A=$7F-A)
	STA sine+$80,x		; 3rd segment
	STA sine-$80,y		; 2nd segment
	;
	DEY
	INX
	CPX #$40		; stop at 1/4
	BNE loop
	;
	; ---
	;
	LDA #$CC
sync2	CMP $FF1D
	BNE sync2
	;
	LDA #$17
	STA $FF06
	;
	LDX #$FF
	STX $FF0C
	STX $FF0D
	INX
	STX $FF19
	STX $FF15
	STX $FF12
	LDA #$10
	STA $FF13
	;
	LDA $FF07
	AND #$40 
	ORA #$88
	STA $FF07
	;
	LDA #text & 255
	STA txtptr
	LDA #text >> 8
	STA txtptr+1
	STX delay
	;
	TXA
il1	STA $0c00,x
	STA $0d00,x
	STA $0e00,x
	STA $0f00,x
	INX
	BNE il1
	;
	JSR PLAYER_FREQ_INIT
	;
	; ---
	;
main	LDA #$B2	; yay, works on NTSC!
sync0	CMP $FF1D
	BNE sync0
	;
	;DEC $FF19
	JSR PLAYER
	JSR vol_down
spc	JSR spacecheck
	;INC $FF19
	;
	LDA #$CB
sync1a	CMP $FF1D
	BNE sync1a
sync1b	CMP $FF1D
	BEQ sync1b
	;        
	INC delay
	LDA delay
nodly	AND #$01	; only every 2nd frame
	BEQ main
	;
	LDA $FF06	; scroll up
	SEC
	SBC #$01
	CMP #$0F
	BNE nowrap
	;
	LDA #$17
	STA $FF06	; set FF06 immediately (before next frame)
	;  
	;DEC $FF19
	JSR up		; move all chars up
	;INC $FF19
	;
	;
newline	LDY #$00
lc1	LDA (txtptr),y
	BEQ lineend
	CMP #$7F	; special flag (end of text)
	BEQ lc5
	CMP #$7E	; special flag (2nd line of 2x2 chars)
	BNE lc4
	;
	LDX #$27
lc3	LDA $0FC0-$28,X	; write 2nd line of 2x2 chars
	CLC
	ADC #$01
	STA $0FC0,X
	DEX
	BPL lc3
	;
	INY
	TYA
	CLC
	ADC txtptr
	STA txtptr
	BCC *+4
	INC txtptr+1
	;
	JMP main
	;
lc5	STA vol_down+1	; start voldown
	JMP lineend
	;
lc4	STA $0FC0,y
	INY
	BNE lc1
lineend	INY
	TYA
	CLC
	ADC txtptr
	STA txtptr
	BCC *+4
	INC txtptr+1
	;
	CPY #$29
	BEQ noplas
	DEY
	LDA #$08	; fill rest of line with spaces
lc2	STA $0FC0,Y
	INY
	CPY #$28
	BNE lc2 
	;
	JMP main
	;
nowrap	STA $FF06
	;
	LDA $FF06
	AND #$01
	BNE noplas
	;
	;DEC $FF19
	JSR plasma
	;INC $FF19
	;
noplas	JMP main
	
plasma
	DEC sine1	; move the stuff...
	DEC sine1
	;         
	INC sine2+1
	LDA sine2+1
	STA sine2b+1
	STA sine2c+1
	STA sine2d+1
	;
	;---
	LDA #12			; number of lines
	STA lines
	;
	LDA #$D8
	STA ptr
	LDA #$00
	STA ptr2
	LDA #$07
	STA ptr+1
	LDA #$08
	STA ptr2+1
	;
pl4	;LAX lines 
	DB $A7			; LAX $00 opcode
	DB lines
	;
	;CLC			; do away with this CLC... less accurate but the difference is not noticable
	ADC sine1
	TAY 
	;
	TXA			; A = lines
	CLC
	ADC sine,y
	STA line_add		; pre calculate Y value
	;
	;JSR $D8AA		; X = lines, get screen position in $C8/C9
	;
	; --- main plasma loop
	;
	LDY #39			; control width
	;
pl3	LDA line_add		;      value for Y (pre calculated)
sine2	ADC sine,y		; plus value for X = plasma!
	;   
	TAX
	LDA plasma_colors,x
	STA (ptr),y 		; draw it
	STA (ptr2),y 		; draw it again
	;
	DEY
	LDA line_add
sine2b	ADC sine,y
	;   
	TAX
	LDA plasma_colors,x
	STA (ptr),y
	STA (ptr2),y
	;
	DEY
	LDA line_add
sine2c	ADC sine,y
	;   
	TAX
	LDA plasma_colors,x
	STA (ptr),y
	STA (ptr2),y
	;
	DEY
	LDA line_add
sine2d	ADC sine,y
	;   
	TAX
	LDA plasma_colors,x
	STA (ptr),y
	STA (ptr2),y
	;
	DEY
	BPL pl3
	;
	LDA ptr
	CLC
	ADC #80
	STA ptr
	BCC *+1
	INC ptr+1
	;
	LDA ptr2
	CLC
	ADC #80
	STA ptr2
	BCC *+1
	INC ptr2+1
	;
	DEC lines
	;
	BPL pl4
	;BMI main_loop		; always jump
	RTS
	
up	LDX #$27
upl	LDA $0C00+01*40,x
	STA $0C00+00*40,x
	LDA $0C00+02*40,x
	STA $0C00+01*40,x
	LDA $0C00+03*40,x
	STA $0C00+02*40,x
	LDA $0C00+04*40,x
	STA $0C00+03*40,x
	LDA $0C00+05*40,x
	STA $0C00+04*40,x
	LDA $0C00+06*40,x
	STA $0C00+05*40,x
	LDA $0C00+07*40,x
	STA $0C00+06*40,x
	LDA $0C00+08*40,x
	STA $0C00+07*40,x
	LDA $0C00+09*40,x
	STA $0C00+08*40,x
	LDA $0C00+10*40,x
	STA $0C00+09*40,x
	LDA $0C00+11*40,x
	STA $0C00+10*40,x
	LDA $0C00+12*40,x
	STA $0C00+11*40,x
	DEX
	BPL upl
	;
	LDX #$27
up3	LDA $0C00+13*40,x
	STA $0C00+12*40,x
	LDA $0C00+14*40,x
	STA $0C00+13*40,x
	LDA $0C00+15*40,x
	STA $0C00+14*40,x
	LDA $0C00+16*40,x
	STA $0C00+15*40,x
	LDA $0C00+17*40,x
	STA $0C00+16*40,x
	LDA $0C00+18*40,x
	STA $0C00+17*40,x
	LDA $0C00+19*40,x
	STA $0C00+18*40,x
	LDA $0C00+20*40,x
	STA $0C00+19*40,x
	LDA $0C00+21*40,x
	STA $0C00+20*40,x
	LDA $0C00+22*40,x
	STA $0C00+21*40,x
	LDA $0C00+23*40,x
	STA $0C00+22*40,x
	LDA $0C00+24*40,x
	STA $0C00+23*40,x
	DEX
	BPL up3
	RTS

vol_down
	LDA #$00
	BEQ no_vol_down
	;
vol_delay
	LDA #$00
	CLC
	ADC #$01
vdspd	CMP #$14
	BNE vd1
	LDA #$00
vd1	STA vol_delay+1
	BNE no_vol_down
	;
	LDA VOLUME
	CLC
	ADC #$09
	CMP #21*9
	BNE do_vol_down
	JMP $FFF6
do_vol_down
	STA VOLUME
	
no_vol_down
	RTS
	
spacecheck
	LDA #$7F
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$10	; Query keyboard for "Space"
	BNE not_pressed
	; space is pressed
	;
	LDA #$2C		; disable space check
	STA spc
	;
	LDA #txtend & 255	; text is over
	STA txtptr
	LDA #txtend >> 8
	STA txtptr+1
	;
	LDA #$FF	; no scroll delay (faster scroll out)
	STA nodly+1
	;
	LSR vdspd+1	; faster vol down
	;
not_pressed
	RTS

text
	CMAP " ",$08
	CMAP "a",$02,$04,$06,$10,$12,$14,$16,$20,$22,$24,$26,$30,$32,$34,$36,$40,$42,$44,$46,$50,$52,$54,$56,$60,$62,$64,$66,$70,$72,$74,$76
	CMAP "A",$0a,$0c,$0e,$18,$1A,$1C,$1E,$28,$2A,$2C,$2E,$38,$3A,$3C,$3E,$48,$4A,$4C,$4E,$58,$5A,$5C,$5E,$68,$6A,$6C,$6E,$78,$7A,$7C,$7E
	CMAP "!",$82,$84,$86,$90,$92,$94,$96
	CMAP ",",$B0,$B2,$B4,$B6
	CMAP "0",$C0,$C2,$C4,$C6,$D0,$D2,$D4,$D6,$E0,$E2,$E4
	
	;   0123456789012345678901234567890123456789
	DB "yYoOuU hHaAvVeE jJuUsStT wWUaAtTcChHeEdD",0
	DB $7E
	DB "nNyYaAnNcCaAtT",0
	DB $7E
	DB "bBlLaAsStTinNgG oOnNtToO yYoOuUrR",0
	DB $7E
	DB "pPlLuUsSsSyY'sS sScCrReEeEnN.",0
	DB $7E
	
	CMAP "A",$70+$80,$71+$80,$72+$80,$73+$80,$74+$80,$75+$80,$76+$80,$77+$80,$78+$80,$79+$80,$7A+$80,$7B+$80,$7C+$80,$7D+$80,$7E+$80,$7F+$80,$08+$80,$09+$80,$0A+$80,$0B+$80,$0C+$80,$0D+$80,$0E+$80,$0F+$80,$6E+$80,$6F+$80
	CMAP "!",$EC,0,0,0,0,0,0,0,0,0,0,0,0,$ED
	
	DB "THE BEST PART WAS WHEN IT SAID NYAN.",0
	
	CMAP " ",$08
	CMAP "a",$02,$04,$06,$10,$12,$14,$16,$20,$22,$24,$26,$30,$32,$34,$36,$40,$42,$44,$46,$50,$52,$54,$56,$60,$62,$64,$66,$70,$72,$74,$76
	CMAP "A",$0a,$0c,$0e,$18,$1A,$1C,$1E,$28,$2A,$2C,$2E,$38,$3A,$3C,$3E,$48,$4A,$4C,$4E,$58,$5A,$5C,$5E,$68,$6A,$6C,$6E,$78,$7A,$7C,$7E
	CMAP "!",$82,$84,$86,$90,$92,$94,$96
	CMAP ",",$B0,$B2,$B4,$B6
	CMAP "0",$C0,$C2,$C4,$C6,$D0,$D2,$D4,$D6,$E0,$E2,$E4
	
	DB 0,0,0
	DB "itT cCaAmMNeE aAnNdD itT wWUeEnNtT.",0
	DB $7E
	DB "aAnNdD nNoOwWU yYoOuU'rReE sStTuUcCkK",0
	DB $7E
	DB "wWUitThH tThHisS hHaAsStTilLyY pPuUtT",0
	DB $7E
	DB "tToOgGeEtThHeErR sScCrRoOlLlL.",0
	DB $7E
	DB 0,0,0
	DB "sSoOmMNeE qQuUicCkK cCrReEdDitTsS:",0
	DB $7E
	DB "oOrRigGinNaAlL: pPrRgGuUitTaArRmMNaAnN",0
	DB $7E
	DB "gGrRaApPhHicCsS: cChHrRoOnNoOsS/",$BE,"aAcCwWU",0
	DB $7E
	DB "cCoOdDeE: cCsSaAbBoO/",$BE,"lLoOdD",0
	DB $7E
	DB 0,0,0
	DB "tTeEcChH nNoOtTeEsS:",0
	DB $7E
	DB "tThHeE dDigGi wWUaAsS pPlLaAyYeEdD aAtT",0
	DB $7E
	DB "9",$E2+8,"2",$C4+8,"3",$C6+8,"7",$D6+8,"hH",$66,$6E,", tTwWUoO cChHaAnNnNeElLsS",0
	DB $7E
	DB "mMNixXeEdD inN rReEaAlLtTimMNeE...",0
	DB $7E
	DB "wWUitThH tThHeE sScCrReEeEnN oOpPeEnN!",0
	DB $7E
	
	CMAP "A",$70+$80,$71+$80,$72+$80,$73+$80,$74+$80,$75+$80,$76+$80,$77+$80,$78+$80,$79+$80,$7A+$80,$7B+$80,$7C+$80,$7D+$80,$7E+$80,$7F+$80,$08+$80,$09+$80,$0A+$80,$0B+$80,$0C+$80,$0D+$80,$0E+$80,$0F+$80,$6E+$80,$6F+$80
	CMAP "!",$EC,0,0,0,0,0,0,0,0,0,0,0,0,$ED
	
	DB "THAT IS TRULY FASCINATING STUFF!",0
	
	CMAP " ",$08
	CMAP "a",$02,$04,$06,$10,$12,$14,$16,$20,$22,$24,$26,$30,$32,$34,$36,$40,$42,$44,$46,$50,$52,$54,$56,$60,$62,$64,$66,$70,$72,$74,$76
	CMAP "A",$0a,$0c,$0e,$18,$1A,$1C,$1E,$28,$2A,$2C,$2E,$38,$3A,$3C,$3E,$48,$4A,$4C,$4E,$58,$5A,$5C,$5E,$68,$6A,$6C,$6E,$78,$7A,$7C,$7E
	CMAP "!",$82,$84,$86,$90,$92,$94,$96
	CMAP ",",$B0,$B2,$B4,$B6
	CMAP "0",$C0,$C2,$C4,$C6,$D0,$D2,$D4,$D6,$E0,$E2,$E4
	
	DB 0,0,0
	DB "tThHaAtT lLeEfFtT nNoO rRoOoOmMN fFoOrR",0
	DB $7E
	DB "eEfFfFeEcCtTsS. wWUeE sStTilLlL",0
	DB $7E
	DB "mMNaAnNaAgGeEdD tToO sSqQuUeEeEzZeE inN",0
	DB $7E
	DB "6",$D4+8," fFuUlLlL fFrRaAmMNeEsS oOfF",0
	DB $7E
	DB "gGfFxX.",0
	DB $7E
	DB 0,0,0
	
	CMAP "A",$70+$80,$71+$80,$72+$80,$73+$80,$74+$80,$75+$80,$76+$80,$77+$80,$78+$80,$79+$80,$7A+$80,$7B+$80,$7C+$80,$7D+$80,$7E+$80,$7F+$80,$08+$80,$09+$80,$0A+$80,$0B+$80,$0C+$80,$0D+$80,$0E+$80,$0F+$80,$6E+$80,$6F+$80
	CMAP "!",$EC,0,0,0,0,0,0,0,0,0,0,0,0,$ED
	
	DB "              CHRONOS SENDS             ",0
	
	CMAP " ",$08
	CMAP "a",$02,$04,$06,$10,$12,$14,$16,$20,$22,$24,$26,$30,$32,$34,$36,$40,$42,$44,$46,$50,$52,$54,$56,$60,$62,$64,$66,$70,$72,$74,$76
	CMAP "A",$0a,$0c,$0e,$18,$1A,$1C,$1E,$28,$2A,$2C,$2E,$38,$3A,$3C,$3E,$48,$4A,$4C,$4E,$58,$5A,$5C,$5E,$68,$6A,$6C,$6E,$78,$7A,$7C,$7E
	CMAP "!",$82,$84,$86,$90,$92,$94,$96
	CMAP ",",$B0,$B2,$B4,$B6
	CMAP "0",$C0,$C2,$C4,$C6,$D0,$D2,$D4,$D6,$E0,$E2,$E4
	
	DB "         gGrReEeEtTinNgGsS tToO         ",0,$7E
	DB "   fFirReE, aAsSsSaAsSsSinNsS, gGsS,    ",0,$7E
	DB "  nNsStT, gGoOtTuU, mMNoOnNaArRcChHyY,  ",0,$7E
	DB "sSinNgGuUlLaArR cCrReEwWU, cChHoOrRuUsS,",0,$7E
	DB "bBaAuUkKnNeEcChHtT, cCoOsSinNeE, tTeEkK,",0,$7E
	DB " tTrRoOnN lLaAmMNeErR tTeEaAmMN, eEvVsS,",0,$7E
	DB "  uUnNlLimMNitTeEdD, rReEsSoOuUrRcCeE,  ",0,$7E
	DB "         bBoOoOzZeE dDeEsSigGnN         ",0,$7E
	DB "             aAnNdD yYoOuU!             ",0,$7E
	DB 0,0
	
	CMAP "A",$70+$80,$71+$80,$72+$80,$73+$80,$74+$80,$75+$80,$76+$80,$77+$80,$78+$80,$79+$80,$7A+$80,$7B+$80,$7C+$80,$7D+$80,$7E+$80,$7F+$80,$08+$80,$09+$80,$0A+$80,$0B+$80,$0C+$80,$0D+$80,$0E+$80,$0F+$80,$6E+$80,$6F+$80
	CMAP "!",$EC,0,0,0,0,0,0,0,0,0,0,0,0,$ED
	
	DB "AND FINALLY",0
	
	CMAP " ",$08
	CMAP "a",$02,$04,$06,$10,$12,$14,$16,$20,$22,$24,$26,$30,$32,$34,$36,$40,$42,$44,$46,$50,$52,$54,$56,$60,$62,$64,$66,$70,$72,$74,$76
	CMAP "A",$0a,$0c,$0e,$18,$1A,$1C,$1E,$28,$2A,$2C,$2E,$38,$3A,$3C,$3E,$48,$4A,$4C,$4E,$58,$5A,$5C,$5E,$68,$6A,$6C,$6E,$78,$7A,$7C,$7E
	CMAP "!",$82,$84,$86,$90,$92,$94,$96
	CMAP ",",$B0,$B2,$B4,$B6
	CMAP "0",$C0,$C2,$C4,$C6,$D0,$D2,$D4,$D6,$E0,$E2,$E4
	
	DB "gGrReEeEtTinNgGsS tToO",$74,$7C,0,$7E
	DB "eEvVeErRyYoOnNeE aAtT aArRoOkK!",0
	DB $7E,0
txtend	DB $7F
	DB 0,0,0,0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0,0,0,0
	
	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"
;eof